Gem::Specification.new do |s|
  s.name = %q{rspec}
  s.version = "1.0.8"
  s.date = %q{2007-08-13}
  s.summary = %q{RSpec-1.0.8 (r2338) - BDD for Ruby http://rspec.rubyforge.org/}
  s.email = %q{rspec-devel@rubyforge.org}
  s.homepage = %q{http://rspec.rubyforge.org}
  s.rubyforge_project = %q{rspec}
  s.description = %q{RSpec is a behaviour driven development (BDD) framework for Ruby.  RSpec was created in response to Dave Astels' article _A New Look at Test Driven Development_ which can be read at: http://daveastels.com/index.php?p=5  RSpec is intended to provide the features discussed in Dave's article.}
  s.autorequire = %q{spec}
  s.default_executable = %q{spec}
  s.has_rdoc = true
  s.authors = ["RSpec Development Team"]
  s.files = ["CHANGES", "EXAMPLES.rd", "MIT-LICENSE", "Rakefile", "README", "UPGRADE", "lib/autotest/discover.rb", "lib/autotest/rspec.rb", "lib/spec/dsl/behaviour.rb", "lib/spec/dsl/behaviour_callbacks.rb", "lib/spec/dsl/behaviour_eval.rb", "lib/spec/dsl/behaviour_factory.rb", "lib/spec/dsl/composite_proc_builder.rb", "lib/spec/dsl/configuration.rb", "lib/spec/dsl/description.rb", "lib/spec/dsl/errors.rb", "lib/spec/dsl/example.rb", "lib/spec/dsl/example_matcher.rb", "lib/spec/dsl/example_should_raise_handler.rb", "lib/spec/dsl.rb", "lib/spec/expectations/differs/default.rb", "lib/spec/expectations/errors.rb", "lib/spec/expectations/extensions/object.rb", "lib/spec/expectations/extensions/string_and_symbol.rb", "lib/spec/expectations/extensions.rb", "lib/spec/expectations/handler.rb", "lib/spec/expectations.rb", "lib/spec/extensions/object.rb", "lib/spec/extensions.rb", "lib/spec/matchers/be.rb", "lib/spec/matchers/be_close.rb", "lib/spec/matchers/change.rb", "lib/spec/matchers/eql.rb", "lib/spec/matchers/equal.rb", "lib/spec/matchers/has.rb", "lib/spec/matchers/have.rb", "lib/spec/matchers/include.rb", "lib/spec/matchers/match.rb", "lib/spec/matchers/operator_matcher.rb", "lib/spec/matchers/raise_error.rb", "lib/spec/matchers/respond_to.rb", "lib/spec/matchers/satisfy.rb", "lib/spec/matchers/throw_symbol.rb", "lib/spec/matchers.rb", "lib/spec/mocks/argument_constraint_matchers.rb", "lib/spec/mocks/argument_expectation.rb", "lib/spec/mocks/error_generator.rb", "lib/spec/mocks/errors.rb", "lib/spec/mocks/extensions/object.rb", "lib/spec/mocks/message_expectation.rb", "lib/spec/mocks/methods.rb", "lib/spec/mocks/mock.rb", "lib/spec/mocks/order_group.rb", "lib/spec/mocks/proxy.rb", "lib/spec/mocks/space.rb", "lib/spec/mocks/spec_methods.rb", "lib/spec/mocks.rb", "lib/spec/rake/spectask.rb", "lib/spec/rake/verify_rcov.rb", "lib/spec/runner/backtrace_tweaker.rb", "lib/spec/runner/behaviour_runner.rb", "lib/spec/runner/command_line.rb", "lib/spec/runner/drb_command_line.rb", "lib/spec/runner/extensions/kernel.rb", "lib/spec/runner/extensions/object.rb", "lib/spec/runner/formatter/base_formatter.rb", "lib/spec/runner/formatter/base_text_formatter.rb", "lib/spec/runner/formatter/failing_behaviours_formatter.rb", "lib/spec/runner/formatter/failing_examples_formatter.rb", "lib/spec/runner/formatter/html_formatter.rb", "lib/spec/runner/formatter/progress_bar_formatter.rb", "lib/spec/runner/formatter/rdoc_formatter.rb", "lib/spec/runner/formatter/snippet_extractor.rb", "lib/spec/runner/formatter/specdoc_formatter.rb", "lib/spec/runner/formatter.rb", "lib/spec/runner/heckle_runner.rb", "lib/spec/runner/heckle_runner_unsupported.rb", "lib/spec/runner/option_parser.rb", "lib/spec/runner/options.rb", "lib/spec/runner/reporter.rb", "lib/spec/runner/spec_parser.rb", "lib/spec/runner.rb", "lib/spec/test_case_adapter.rb", "lib/spec/translator.rb", "lib/spec/version.rb", "lib/spec.rb", "spec/autotest/discover_spec.rb", "spec/autotest/rspec_spec.rb", "spec/autotest_helper.rb", "spec/spec/dsl/behaviour_eval_spec.rb", "spec/spec/dsl/behaviour_factory_spec.rb", "spec/spec/dsl/behaviour_spec.rb", "spec/spec/dsl/composite_proc_builder_spec.rb", "spec/spec/dsl/configuration_spec.rb", "spec/spec/dsl/description_spec.rb", "spec/spec/dsl/example_class_spec.rb", "spec/spec/dsl/example_instance_spec.rb", "spec/spec/dsl/example_matcher_spec.rb", "spec/spec/dsl/example_should_raise_spec.rb", "spec/spec/dsl/predicate_matcher_spec.rb", "spec/spec/dsl/shared_behaviour_spec.rb", "spec/spec/expectations/differs/default_spec.rb", "spec/spec/expectations/extensions/object_spec.rb", "spec/spec/expectations/fail_with_spec.rb", "spec/spec/matchers/be_close_spec.rb", "spec/spec/matchers/be_spec.rb", "spec/spec/matchers/change_spec.rb", "spec/spec/matchers/description_generation_spec.rb", "spec/spec/matchers/eql_spec.rb", "spec/spec/matchers/equal_spec.rb", "spec/spec/matchers/exist_spec.rb", "spec/spec/matchers/handler_spec.rb", "spec/spec/matchers/has_spec.rb", "spec/spec/matchers/have_spec.rb", "spec/spec/matchers/include_spec.rb", "spec/spec/matchers/match_spec.rb", "spec/spec/matchers/matcher_methods_spec.rb", "spec/spec/matchers/mock_constraint_matchers_spec.rb", "spec/spec/matchers/operator_matcher_spec.rb", "spec/spec/matchers/raise_error_spec.rb", "spec/spec/matchers/respond_to_spec.rb", "spec/spec/matchers/satisfy_spec.rb", "spec/spec/matchers/throw_symbol_spec.rb", "spec/spec/mocks/any_number_of_times_spec.rb", "spec/spec/mocks/argument_expectation_spec.rb", "spec/spec/mocks/at_least_spec.rb", "spec/spec/mocks/at_most_spec.rb", "spec/spec/mocks/bug_report_10260_spec.rb", "spec/spec/mocks/bug_report_11545_spec.rb", "spec/spec/mocks/bug_report_7611_spec.rb", "spec/spec/mocks/bug_report_7805_spec.rb", "spec/spec/mocks/bug_report_8165_spec.rb", "spec/spec/mocks/bug_report_8302_spec.rb", "spec/spec/mocks/failing_mock_argument_constraints_spec.rb", "spec/spec/mocks/mock_ordering_spec.rb", "spec/spec/mocks/mock_space_spec.rb", "spec/spec/mocks/mock_spec.rb", "spec/spec/mocks/multiple_return_value_spec.rb", "spec/spec/mocks/null_object_mock_spec.rb", "spec/spec/mocks/once_counts_spec.rb", "spec/spec/mocks/options_hash_spec.rb", "spec/spec/mocks/partial_mock_spec.rb", "spec/spec/mocks/partial_mock_using_mocks_directly_spec.rb", "spec/spec/mocks/passing_mock_argument_constraints_spec.rb", "spec/spec/mocks/precise_counts_spec.rb", "spec/spec/mocks/record_messages_spec.rb", "spec/spec/mocks/stub_spec.rb", "spec/spec/mocks/twice_counts_spec.rb", "spec/spec/package/bin_spec_spec.rb", "spec/spec/runner/behaviour_runner_spec.rb", "spec/spec/runner/command_line_spec.rb", "spec/spec/runner/context_matching_spec.rb", "spec/spec/runner/drb_command_line_spec.rb", "spec/spec/runner/execution_context_spec.rb", "spec/spec/runner/extensions/bug_report_10577_spec.rb", "spec/spec/runner/extensions/kernel_spec.rb", "spec/spec/runner/formatter/failing_behaviours_formatter_spec.rb", "spec/spec/runner/formatter/failing_examples_formatter_spec.rb", "spec/spec/runner/formatter/html_formatter_spec.rb", "spec/spec/runner/formatter/progress_bar_formatter_dry_run_spec.rb", "spec/spec/runner/formatter/progress_bar_formatter_failure_dump_spec.rb", "spec/spec/runner/formatter/progress_bar_formatter_spec.rb", "spec/spec/runner/formatter/rdoc_formatter_dry_run_spec.rb", "spec/spec/runner/formatter/rdoc_formatter_spec.rb", "spec/spec/runner/formatter/snippet_extractor_spec.rb", "spec/spec/runner/formatter/specdoc_formatter_dry_run_spec.rb", "spec/spec/runner/formatter/specdoc_formatter_spec.rb", "spec/spec/runner/heckle_runner_spec.rb", "spec/spec/runner/heckler_spec.rb", "spec/spec/runner/noisy_backtrace_tweaker_spec.rb", "spec/spec/runner/object_ext_spec.rb", "spec/spec/runner/option_parser_spec.rb", "spec/spec/runner/options_spec.rb", "spec/spec/runner/quiet_backtrace_tweaker_spec.rb", "spec/spec/runner/reporter_spec.rb", "spec/spec/runner/spec_parser_spec.rb", "spec/spec/spec_classes.rb", "spec/spec/translator_spec.rb", "spec/spec_helper.rb", "examples/auto_spec_description_example.rb", "examples/before_and_after_example.rb", "examples/behave_as_example.rb", "examples/custom_expectation_matchers.rb", "examples/custom_formatter.rb", "examples/dynamic_spec.rb", "examples/file_accessor.rb", "examples/file_accessor_spec.rb", "examples/greeter_spec.rb", "examples/helper_method_example.rb", "examples/io_processor.rb", "examples/io_processor_spec.rb", "examples/legacy_spec.rb", "examples/mocking_example.rb", "examples/multi_threaded_behaviour_runner.rb", "examples/partial_mock_example.rb", "examples/pending_example.rb", "examples/predicate_example.rb", "examples/priority.txt", "examples/shared_behaviours_example.rb", "examples/spec_helper.rb", "examples/stack.rb", "examples/stack_spec.rb", "examples/stubbing_example.rb", "examples/test_case_adapter_example.rb", "examples/test_case_spec.rb", "plugins/mock_frameworks", "plugins/mock_frameworks/flexmock.rb", "plugins/mock_frameworks/mocha.rb", "plugins/mock_frameworks/rr.rb", "plugins/mock_frameworks/rspec.rb", "bin/spec", "bin/spec_translator"]
  s.rdoc_options = ["--title", "RSpec", "--line-numbers", "--inline-source", "--main", "README"]
  s.extra_rdoc_files = ["README", "CHANGES", "MIT-LICENSE", "UPGRADE"]
  s.executables = ["spec", "spec_translator"]
end
